Reference

REST API

Base URL: https://api.attoscloud.com/api/v1

Authentication

bash
curl https://api.attoscloud.com/api/v1/datasets \
  -H "Authorization: Bearer at_live_9f3a21b47c02"

POST /datasets/compile

bash
curl -X POST https://api.attoscloud.com/api/v1/datasets/compile \
  -H "Authorization: Bearer $ATTOS_KEY" \
  -F "file=@users.csv" \
  -F "key_column=user_id"

Response

json
{
  "dataset_id": "ds_a1b2c3d4",
  "keys": 12400000,
  "artifact_url": "https://cdn.attos.io/ds_a1b2c3d4.nh",
  "size_bytes": 32505856,
  "compile_ms": 1912,
  "avg_lookup_ns": 19.7
}

Rate limits

1000 requests / minute per key. Compilation jobs are queued per project.

PUT /datasets/{id}/data

Updates the data for an existing dataset. This triggers a recompilation of the .attos binary file and creates a new immutable version of the dataset in cloud storage.

Example: Multipart Form Upload

bash
curl -X PUT https://api.attoscloud.com/api/v1/datasets/123e4567/data \
  -H "Authorization: Bearer $ATTOS_KEY" \
  -F "file=@data.csv"

Rate Limits & Billing

Dataset updates are limited based on your organization's billing tier:

  • Free Tier: 10 updates per month. Exceeding this limit will return a 429 Too Many Requests error.
  • Growth Tier: 1000 included updates per month. Overage usage will be metered automatically to your linked billing account via Dodo Payments.